# -*- coding: utf-8 -*-
"""
Created on Mon May 21 13:50:57 2018

@author: katayan
"""

#_Pythonの基礎__________
#__1) コメント__

# コメント行です

123 # 行の途中からでもコメントを書けます


#__2) Pythonの主要データ型__
#___(1) 文字列

'メッシュ農業気象データ'

"メッシュ農業気象データ"

'"メッシュ"農業気象データ'

"That's a good idea."


'メッシュ
農業気象データ'

'''
メッシュ
農業気象
データ
'''


#___(2)数値

1

1.


#__3) 四則演算と代入文__

"メッシュ" + "農業" + "気象"

"実習" + 1

"実習" + "1"

# 【練習問題】

1 + 2

1.0 + 2

2 - 1

2.0 - 1

2 * 2

2 * 2.0

6 / 3

7 / 3

7 // 3

7 % 3

"メッシュ" + "農業" + "気象"

"農業" * 3

"農業" + 5

"農業" + "5"


#__4) 変数と代入文__

a = 100
a = a + 10
a


#__5) 累積代入文__

a = 100
a += 10
a

a = 100
a -= 10
a

a = 100
a *= 10
a

a = 100
a /= 10
a


#__6) 比較演算子__

a = 100
b = 200
c = 50
a < b > c  


#__7) Pythonで使われる特徴的なデータ__
#___(1) リスト

lis1 = [1, 2, 3]
lis2 = [4, 5]
lis1 + lis2

lis = [1, 2, 3]
lis += [4, 5]
lis

lis = [1, 2, 3]
lis.append("後はたくさん")
lis

lis = [10, 20, 30, 40]
lis.insert(2,100)
lis

lis = ["a", "b", "c", "d"]
lis.pop(2)
lis

lis = ["a", "b", "c", "d"]
lis.index("d")

lis = [10, 1, 7, 2]
lis.sort()
lis

lis = [1, 2, 3, 4]
lis.reverse()
lis

lis = ["零", "一", "二", "三", "四"]
lis[1]

lis = ["零", "一", "二", "三", "四", "五", "六", "七"]
lis[1:6]


lis[:]
lis[3:]
lis[:4]
lis[-5:-3]
lis[-2:]
lis[:-3]

mixed = [10, 20, "Mesh", [100, 200, 300]]
mixed[3][1]

lis = [1, 2, 3]
lis[0] = "メッシュ"
lis

lis[1:3] = ["農業", "気象"]
lis


#___(2) タプル

tsukuba = (36.0270, 140.1104)
tsukuba.append(150.3)


#___(3) 辞書

station = {"name":"Tsukuba", 
           "lat":36.0270, 
           "lon":140.1104,
           "asl":-999.9}
station

station["name"]

station["asl"] = 11.3 
station["asl"]

station.values()

station.keys()


#_Pythonの制御構文__________
#__1) for文による繰り返し（ループ）__

for i in [0, 1, 2]:
    print(i)

for i in [0, 1, 2]:
    print(i)
print(i,"までで終了")

for i in range(3):
    print(i)
print(i,"までで終了")


# 【練習問題】

for i in range(1, 5) :
    print(i)
print(i,"までで終了")

for i in range(1, 10, 2) :
    print(i)
print(i,"までで終了")


#__2) リスト内包表記__

[i * 5 + 1 for i in range(5)]

x = []
for i in range(5):
    x.append(i * 5 + 1)
x

#__3) if, elif, else による条件分岐__

value = 10
if value <= 3:
    print(vaｌue, "じゃすくないな。")

elif 3 < value <= 5:
    print(vaｌue, "だしまあまあか。")

else:
    print(vaｌue, "だなんてラッキー。")


#__4) break文とcontinue文について__

for i in range(10):
   if i == 3:
       break

   print(i)
    
for i in range(10):
    if i == 3:
        continue

    print(i)


#_Pythonの関数__________

def calc_add(a, b):
    c = a + b
    return c

x1, x2 = 2, 3
y = calc_add(x1, x2)
y

def calc_addif(a, b):
    c = a + b
    d = a - b
    return c, d

x1, x2 = 2, 3
y, z = calc_addif(x1, x2)
y
z

def calc_add_tax(a, b, tax=0.08):
    c = a + b
    c += c * tax
    return c

calc_add_tax(100, 200)

calc_add_tax(100, 200, tax=0.05)


#_ライブラリとインポート__________


#_数値計算ライブラリNumPy__________

import numpy as np


#__1) 多次元数値配列 ndarry__

data = [1, 2, 3]
npdata = np.array(data)
npdata

npdata + npdata

npdata - npdata

npdata * npdata

npdata / npdata

npdata + 10

npdata - 10

npdata * 10

npdata / 10

npdata /10 * data

data + data

data - data

data * data

data / data


#__2) 3次元ndarrayの添え字__

arr = np.zeros((3, 4, 5))
arr

arr = np.arange(60.0).reshape(3, 4, 5)
arr

arr[0, 1, 2]

arr[2, :, :]

arr[:, 2, 3]


#__3) 無効値 nan__

arr[0, 1, 2] = np.nan
arr

np.isnan(arr)

#【練習問題】

~np.isnan(arr)


#__4) クラスの属性__

len(arr)

len(arr[0])

arr.shape

